<!-- SIForge.org News Ticker BEGIN -->
<?
//
// -=( SIForge.org News Ticker )=-
//
// Copyright (C) 2004 SIForge.org, Marco Lamberto
//
//  This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2, or (at your option) any later
// version.
//
//  This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//


// -=( USAGE )=-
//
// Simply "include('siforgeticker.php');".
//


// -=( CONFIGURABLE STUFF )=-
//
// You can customize the following params.
// More layout options can be modifed with CSS properties of the
// "siforgeticker" object id (see the "style" tag below).
//

// This file MUST be writable by the web server
$SIFT_CACHE_FILE   = 'siforgeticker.cache';

// The maximum number of news to show (valid range is 1 to 15)
$SIFT_MAX_NEWS     = 15;

// The ticker box width in pixels
$SIFT_TICKER_WIDTH = '200';

//
?>


<style type='text/css'>
#siforgeticker {
  width: <?=$SIFT_TICKER_WIDTH?>px;
  font-size: 11px;

  border: solid 1px black;
  font-family: arial, verdana, helvetica, sans-serif;
}

#siforgeticker td {
  border-top: dotted 2px #ccc;
}

#siforgeticker td {
  vertical-align: top;
}

#siforgeticker th {
  text-align: left;
}

#siforgeticker img {
  border: 0;
}

#siforgeticker a {
  text-decoration: none;
  display: block;
}

#siforgeticker td a:hover {
  text-decoration: none;
  background: #ccc;
}
</style>


<table id='siforgeticker'>
<th colspan='2'>
  <a href="http://www.siforge.org/"><img
    src="http://www.siforge.org/images/skin/default/sidebar_logo.gif" /></a>
</th>
<?
  //
  // wasModified
  //
  function wasModified($domain, $file, $cached)
  {
    if (!file_exists($cached)) {
      return TRUE;
    }
    
    $s = stat($cached);
    if (!$s[7]) {
      return TRUE;
    }

    $os = fsockopen($domain, 80, $errno, $errstr, 30);

    $header = "HEAD $file HTTP/1.0\r\nHost: $domain\r\nIf-Modified-Since: " .
      gmdate("D, d M Y H:i:s", filemtime($cached)) .
      ' GMT' .
      "\r\n\r\n";

    $rv = FALSE;

    if (!$os) {
      echo "<!-- wasModified:ERROR $errstr ($errno) -->";
    } else {
      fputs ($os, $header);
      $rv = preg_match('#^HTTP/1\.. 200 OK#', fgets($os, 1024));
      fclose($os);
    }

    return $rv;
  }


  //
  // updateCache
  //
  function updateCache($domain, $file, $cached)
  {
    if (!wasModified($domain, $file, $cached)) {
      return;
    }

    if (!($is = fopen("http://$domain/$file", 'r'))) {
      echo "<!-- updateCache:ERROR cannot open 'http://$domain/$file' -->";
      return;
    }
    if (!($os = fopen($cached, 'w'))) {
      echo "<!-- updateCache:ERROR cannot open for writing '$cached' -->";
      return;
    }

    while (!feof($is)) {
      fwrite($os, fgets($is, 1024));
    }

    fclose($os);
    fclose($is);
  }


  //
  // main block
  //

  updateCache('www.siforge.org', '/backend/recentarticles.txt',
    $SIFT_CACHE_FILE);

  if (file_exists($SIFT_CACHE_FILE) && $is = fopen($SIFT_CACHE_FILE, 'r')) {
    for ($i = 0; $i < $SIFT_MAX_NEWS && !feof($is); $i++) {
      $title  = rtrim(fgets($is, 1024));
      $date   = rtrim(fgets($is, 1024));
      preg_match('/(\d{4})(\d{2})(\d{2})/', $date, $m);
      $date   = $m[3] . '/' . $m[2] . '<br/>' . $m[1];
      $url    = rtrim(fgets($is, 1024));

      if (!feof($is)) {
?>
<tr>
  <td align="center"><?=$date?></td>
  <td><a href="<?=$url?>"><?=$title?></a></td>
</tr>
<?
      }
    }
    fclose($is);
  }
?>
</table>


<?
// vim:ts=2 expandtab:
?>
<!-- SIForge.org News Ticker END -->
